unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, ShellAPI, TurboImg, jpeg, Param, StdCtrls, ComCtrls, Math,
  Clipbrd, GrphPrev, GIFImage, DropSource, DropTarget, DropMetaSource,
  DropBMPSource, DropMetaTarget, DropPictureTarget;

var
  CF_JFIF: Word;

type
  TFrameForm = class(TForm)
    MainMenu1: TMainMenu;
    ScrollBox1: TScrollBox;
    Panel1: TPanel;
    Panel2: TPanel;
    TurboImage1: TTurboImage;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Parameter1: TParameter;
    TrackBar1: TTrackBar; // \{̃o[
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton; // \{߂{^
    Edit1: TMenuItem;
    U1: TMenuItem;
    O1: TMenuItem;
    N3: TMenuItem;
    Octree2561: TMenuItem;
    MedianCut2561: TMenuItem;
    MedianCutByVariance2561: TMenuItem;
    MedianCut2562: TMenuItem;
    MedianCut2563: TMenuItem;
    N4: TMenuItem;
    PixelFormat2561: TMenuItem;
    N5: TMenuItem;
    N901: TMenuItem;
    N1801: TMenuItem;
    N2701: TMenuItem;
    N8: TMenuItem;
    R1: TMenuItem;
    O2: TMenuItem;
    H1: TMenuItem;
    N2: TMenuItem;
    A1: TMenuItem;
    T1: TMenuItem;
    Panel3: TPanel;
    DropMetaSource1: TDropMetaSource;
    DropBMPSource1: TDropBMPSource;
    DropPictureTarget1: TDropPictureTarget;
    N6: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Panel4: TPanel;
    Button2: TButton; // 邳ERgXgEK}lEPx肷{^
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label3: TLabel;
    TrackBar2: TTrackBar; // 邳̃o[
    Label4: TLabel;
    Label5: TLabel;
    TrackBar3: TTrackBar; // RgXg̃o[
    Label6: TLabel;
    Label7: TLabel;
    TrackBar4: TTrackBar; // K}l̃o[
    Label8: TLabel;
    Label9: TLabel;
    TrackBar5: TTrackBar; // Px̃o[
    Label10: TLabel;
    Edit3: TEdit;
    UpDown2: TUpDown;
    Button4: TButton; // GbW{^
    Edit4: TEdit;
    UpDown3: TUpDown;
    Button5: TButton; // ␳{^
    ComboBox1: TComboBox;
    Label12: TLabel;
    Button6: TButton;
    N7: TMenuItem;
    S1: TMenuItem;
    Button7: TButton;
    Edit5: TEdit;
    UpDown4: TUpDown;
    TabSheet3: TTabSheet;
    Button8: TButton;
    Edit6: TEdit;
    UpDown5: TUpDown;
    Button9: TButton;
    Edit7: TEdit;
    UpDown6: TUpDown;
    Button10: TButton;
    Edit8: TEdit;
    UpDown7: TUpDown;
    Panel5: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Edit9: TEdit;
    UpDown8: TUpDown;
    Edit10: TEdit;
    UpDown9: TUpDown;
    Label13: TLabel;
    Label14: TLabel;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Panel6: TPanel;
    ComboBox2: TComboBox;
    Label15: TLabel;
    Label16: TLabel;
    ComboBox3: TComboBox;
    Edit11: TEdit;
    UpDown10: TUpDown;
    Button15: TButton;
    N9: TMenuItem;
    V1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    T2: TMenuItem;
    PrintDialog1: TPrintDialog;
    TrackBar6: TTrackBar;
    Label11: TLabel;
    Label17: TLabel;
    Help1: TMenuItem;
    H2: TMenuItem;
    About1: TMenuItem;
    Label19: TLabel;
    Edit2: TEdit;
    UpDown1: TUpDown;
    Label20: TLabel;
    L1: TMenuItem;
    Label18: TLabel;
    Label21: TLabel;
    Panel7: TPanel;
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure U1Click(Sender: TObject);
    procedure O1Click(Sender: TObject);
    procedure Octree2561Click(Sender: TObject);
    procedure MedianCut2561Click(Sender: TObject);
    procedure MedianCutByVariance2561Click(Sender: TObject);
    procedure MedianCut2562Click(Sender: TObject);
    procedure MedianCut2563Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure PixelFormat2561Click(Sender: TObject);
    procedure N901Click(Sender: TObject);
    procedure N1801Click(Sender: TObject);
    procedure N2701Click(Sender: TObject);
    procedure R1Click(Sender: TObject);
    procedure H1Click(Sender: TObject);
    procedure A1Click(Sender: TObject);
    procedure TurboImage1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure T1Click(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TurboImage1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DropPictureTarget1Drop(Sender: TObject;
      ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure S1Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure V1Click(Sender: TObject);
    procedure T2Click(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure H2Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure L1Click(Sender: TObject);
  private
    { Private 錾 }
    DragPoint: TPoint;
    function Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
    function Clipboard2Stream(Format: Word; MemStream: TMemoryStream): Boolean;
    procedure GetJPEG; // Nbv{[h JPEG `̃f[^荞ގ葱
    procedure GetGIF; // Nbv{[h GIF `̃f[^荞ގ葱
    procedure AcceptFiles(var msg: TMessage); message WM_DROPFILES;
  public
    { Public 錾 }
    OpenDir: String;           // tACJtH_
    SaveDir: String;           // tACۑtH_
    DataName: String;          // ݂̉摜f[^Ƃĕۑt@C
    FileName: String;          // ݊JĂt@C̃tpX
    FileSize: String;          // t@CTCY
    DispSize: String;          // \TCY
    BitCount: String;          // 摜̃rbg
    BmpType: String;           // rbg}bvɊւ邻̑̏
    OrgBitmap: TBitmap;        // 炩̕ύXÕIWỉ摜
    TrimArea: TRect;           // g~OGA
    MSFactor: TSize;           // Metafile ̏ꍇ̃XP[t@N^[
    procedure MakeOrgBitmap;   // ݂̉摜 OrgBitmap ɕۑ葱
    procedure MakeDataName;    // ݂̉摜f[^t@Cɕۑ葱
    procedure DeleteDataName;  // f[^t@C폜葱
    procedure OpenFile(FName: String); // tACJ葱
    procedure Undo;            // AhEsȂ葱
    procedure DrawHistgram;    // qXgO\葱
    procedure AmendImage;      // PxEK}lERgXgE邳𒲐葱
    procedure DrawInfor;       // LvVɉ摜̏\B
    procedure TrimInit;        // g~OGA̕`Jnׂ̎葱
    procedure DrawTrimArea;    // g~OGA`悷葱
    procedure TrimEnd;         // g~OGA̕`Iׂ̎葱
    function GraphicType: Integer; // ݂̃OtBbN̎ނԂ֐
    function PixelType: Integer; // ݂ PixelFormat ̒lԂ֐
    function HType: Integer;   // ݂ HandleType ̒lԂ֐
  end;

var
  FrameForm: TFrameForm;

implementation

uses Histgram, Preview;

{$R *.DFM}

procedure TFrameForm.AcceptFiles(var msg: TMessage);
var
  Buf: array[0..255] of Char;
begin
  { hbvꂽt@CtpXŎ擾B}
  DragQueryFile(msg.WParam, 0, Buf, 255);
  DeleteDataName; // f[^t@C폜B
  FileName := String(Buf);
  DataName := FileName;
  OpenFile(DataName);
  UpDown10.Position := -1;
  PageControl1.ActivePage := TabSheet1;
  TrackBar6.SetFocus;
end;

procedure TFrameForm.Open1Click(Sender: TObject);
begin
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  OpenDialog1.InitialDir := OpenDir;
  if OpenDialog1.Execute then
  begin
    DeleteDataName; // f[^t@C폜B
    FileName := OpenDialog1.FileName;
    DataName := FileName;
    OpenFile(DataName);
    UpDown10.Position := -1;
    PageControl1.ActivePage := TabSheet1;
    TrackBar6.SetFocus;
  end;
end;

procedure TFrameForm.Save1Click(Sender: TObject);
var
  Ext: String;
  R: TRect;
  Bmp: TBitmap;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
  Jpeg: TJPEGImage;
  Gif: TGIFImage;
begin
  if TurboImage1.Picture.Graphic = Nil then
    Exit;

  if A1.Checked then
    A1Click(Sender); // g~OGAB

  R := Rect(0, 0, TurboImage1.Width, TurboImage1.Height);

  SaveDialog1.InitialDir := SaveDir;
  SaveDialog1.FileName := ExtractFileName(DataName);

  if SaveDialog1.Execute then
  begin
    Bmp := TBitmap.Create;
    try
      Bmp.Width := TurboImage1.Width;
      Bmp.Height := TurboImage1.Height;
      Bmp.Canvas.StretchDraw(R, TurboImage1.Picture.Graphic);

      Ext := LowerCase(ExtractFileExt(SaveDialog1.FileName));
      if Ext = '.bmp' then
        Bmp.SaveToFile(SaveDialog1.Filename)
      else if (Ext = '.emf') or (Ext = '.wmf') then
      begin
        Mf := TMetafile.Create;
        if Ext = '.emf' then
          Mf.Enhanced := True
        else
          Mf.Enhanced := False;
        try
          Mf.Width := TurboImage1.Width;
          Mf.Height := TurboImage1.Height;
          MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
          try
            if TurboImage1.Picture.Graphic is TMetafile then
              MfCanvas.StretchDraw(R, TurboImage1.Picture.Metafile)
            else
              MfCanvas.Draw(0, 0, Bmp);
          finally
            MfCanvas.Free;
          end;
          Mf.SaveToFile(SaveDialog1.Filename);
        finally
          Mf.Free;
        end;
      end
      else if (Ext = '.jpg') or (Ext = '.jpeg') then
      begin
        Jpeg := TJPEGImage.Create;
        Jpeg.CompressionQuality := UpDown1.Position;
        try
          Jpeg.Assign(Bmp);
          Jpeg.SaveToFile(SaveDialog1.Filename);
        finally
          Jpeg.Free;
        end;
      end
      else if Ext = '.gif' then
      begin
        Gif := TGIFImage.Create;
        try
          Gif.Assign(Bmp);
          Gif.SaveToFile(SaveDialog1.Filename);
        finally
          Gif.Free;
        end;
      end
      else
        TurboImage1.Picture.SaveToFile(SaveDialog1.Filename);
    finally
      Bmp.Free;
    end;
    SaveDir := ExtractFileDir(SaveDialog1.Filename);
  end;
end;

procedure TFrameForm.Exit1Click(Sender: TObject);
begin
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  Close;
end;

procedure TFrameForm.FormShow(Sender: TObject);
var
  Smooth: Boolean;
  Histgram: Boolean;
begin
  Parameter1.Init; // Parameter1 Ăep[^t@C烍[hB
  if Parameter1.Count > 0 then // p[^̃[hɐꍇ
  begin
    Left := Parameter1['Left']; // Integer ^̃f[^𓾂B(Parameter1.VIntegers['Left'] ƓłB)
    Top := Parameter1['Top']; // Integer ^̃f[^𓾂B
    ClientWidth := Parameter1['ClientWidth']; // Integer ^̃f[^𓾂B
    ClientHeight := Parameter1['ClientHeight']; // Integer ^̃f[^𓾂B
    WindowState := TWindowState(Parameter1['WindowState']); // Integer ^̃f[^𓾂B
    UpDown1.Position := Smallint(Parameter1['JPEGQuality']);
    UpDown2.Position := Smallint(Parameter1['GbWx']);
    UpDown3.Position := Smallint(Parameter1['mCYx']);
    UpDown4.Position := Smallint(Parameter1['֊s`惌x']);
    UpDown5.Position := Smallint(Parameter1['UCNx']);
    UpDown6.Position := Smallint(Parameter1['|X^[[Vx']);
    UpDown7.Position := Smallint(Parameter1['֊sox']);
    UpDown8.Position := Smallint(Parameter1['z̕']);
    UpDown9.Position := Smallint(Parameter1['z̃RgXg']);
    if Parameter1.VBools['ž̕'] = True then
      RadioButton1.Checked := True
    else
      RadioButton2.Checked := True;
    OpenDir := Parameter1.VStrings['OpenDir']; // String ^̃f[^𓾂B
    SaveDir := Parameter1.VStrings['SaveDir']; // String ^̃f[^𓾂B
    Smooth :=  Parameter1.VBools['Smooth'];
    Histgram := Parameter1.VBools['Histgram'];
  end
  else // p[^[hoȂꍇ
  begin
    ClientWidth := 650;
    ClientHeight := 500;
    Parameter1.Add('ImageAmender ݒt@C --- ̃t@ĆAҏWȂŉB');
    Parameter1['Left'] := Left; // Parameter1.VIntegers['Left'] ƓłB
    Parameter1['Top'] := Top;
    ClientWidth := 650; Parameter1['ClientWidth'] := ClientWidth;
    ClientHeight := 500; Parameter1['ClientHeight'] := ClientHeight;
    Parameter1['WindowState'] := Integer(WindowState);
    Parameter1['JPEGQuality'] := Integer(UpDown1.Position);
    Parameter1['GbWx'] := Integer(UpDown2.Position);
    Parameter1['mCYx'] := Integer(UpDown3.Position);
    Parameter1['֊s`惌x'] := Integer(UpDown4.Position);
    Parameter1['UCNx'] := Integer(UpDown5.Position);
    Parameter1['|X^[[Vx'] := Integer(UpDown6.Position);
    Parameter1['֊sox'] := Integer(UpDown7.Position);
    Parameter1['z̕'] := Integer(UpDown8.Position);
    Parameter1['z̃RgXg'] := Integer(UpDown9.Position);
    if RadioButton1.Checked then
      Parameter1.VBools['ž̕'] := True
    else
      Parameter1.VBools['ž̕'] := False;
    OpenDir := ''; Parameter1.VStrings['OpenDir'] := OpenDir;
    SaveDir := ''; Parameter1.VStrings['SaveDir'] := SaveDir;
    Smooth := S1.Checked; Parameter1.VBools['Smooth'] := Smooth;
    { qXgOp̃f[^ }
    Parameter1['HLeft'] := 491;
    Parameter1['HTop'] := 355;
    Parameter1['HClientWidth'] := 294;
    Parameter1['HClientHeight'] := 209;
    Parameter1['HWindowState'] := Integer(wsNormal);
    Histgram := H1.Checked; Parameter1.VBools['Histgram'] := Histgram;
    { vr[p̃f[^ }
    Parameter1['PLeft'] := 240;
    Parameter1['PTop'] := 235;
    Parameter1['PClientWidth'] := 454;
    Parameter1['PClientHeight'] := 294;
    Parameter1['PWindowState'] := Integer(wsNormal);
    Parameter1['PrintRatio'] := 100;
    Parameter1['PreviewRatio'] := 20;
    Parameter1['GraphicMode'] := Integer(gmMetafile);
  end;
  if Smooth then
    S1Click(Sender);
  if Histgram then
    H1Click(Sender);
  DataName := '';
  FileName := '';
  FileSize := '';
  DispSize := '';
  BitCount := '';
  BmpType := '';
  TurboImage1.Picture.Graphic := Nil;
  MSFactor := TurboImage1.MScaleFactor; // Metafile ̏ꍇ̃XP[t@N^[
  OrgBitmap := TBitmap.Create; // 炩̕ύXÕIWỉ摜
  TrimArea := Rect(0, 0, 100, 100);

  { R}hCɗ^ꂽt@C΂擾B}
  DeleteDataName; // f[^t@C폜B
  if ParamCount >= 1 then
  begin
    FileName := ParamStr(1);
    DataName := FileName;
    OpenFile(DataName);
    UpDown10.Position := -1;
    PageControl1.ActivePage := TabSheet1;
    TrackBar6.SetFocus;
  end;
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if WindowState <> wsMaximized then
  begin
    Parameter1['Left'] := Left;
    Parameter1['Top'] := Top;
    Parameter1['ClientWidth'] := ClientWidth;
    Parameter1['ClientHeight'] := ClientHeight;
  end;
  Parameter1['WindowState'] := Integer(WindowState);
  Parameter1['JPEGQuality'] := Integer(UpDown1.Position);
  Parameter1['GbWx'] := Integer(UpDown2.Position);
  Parameter1['mCYx'] := Integer(UpDown3.Position);
  Parameter1['֊s`惌x'] := Integer(UpDown4.Position);
  Parameter1['UCNx'] := Integer(UpDown5.Position);
  Parameter1['|X^[[Vx'] := Integer(UpDown6.Position);
  Parameter1['֊sox'] := Integer(UpDown7.Position);
  Parameter1['z̕'] := Integer(UpDown8.Position);
  Parameter1['z̃RgXg'] := Integer(UpDown9.Position);
  if RadioButton1.Checked then
    Parameter1.VBools['ž̕'] := True
  else
    Parameter1.VBools['ž̕'] := False;
  Parameter1.VStrings['OpenDir'] := OpenDir;
  Parameter1.VStrings['SaveDir'] := SaveDir;
  Parameter1.VBools['Smooth'] := S1.Checked;
  { qXgOp̃f[^ }
  if H1.Checked then
  begin
    if HistgramForm.WindowState <> wsMaximized then
    begin
      Parameter1['HLeft'] := HistgramForm.Left;
      Parameter1['HTop'] := HistgramForm.Top;
      Parameter1['HClientWidth'] := HistgramForm.ClientWidth;
      Parameter1['HClientHeight'] := HistgramForm.ClientHeight;
    end;
    Parameter1['HWindowState'] := Integer(HistgramForm.WindowState);
  end;
  Parameter1.VBools['Histgram'] := H1.Checked;

  Parameter1.SaveToFile;
  OrgBitmap.Free;
  DeleteDataName; // f[^t@C폜B
end;

procedure TFrameForm.TrackBar1Change(Sender: TObject);
var
  Area: Boolean;
  W, H: Integer;
begin
  Area := A1.Checked;
  if TrackBar1.Position = 0 then
  begin
    TrackBar1.Position := TrackBar1.Frequency;
    Exit;
  end;
  Label2.Caption := '\{ ( ' + IntToStr(TrackBar1.Position) + ' % )';
  if (Tag = -1) or (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if Area then
    A1Click(Sender); // g~OGAB

  W := TurboImage1.Picture.Graphic.Width * TrackBar1.Position div 100;
  H := TurboImage1.Picture.Graphic.Height * TrackBar1.Position div 100;
  TurboImage1.Width := W;
  TurboImage1.Height := H;

  if Area then
    A1Click(Sender); // g~OGA\B
  DrawInfor;     // LvVɉ摜̏\B
end;

procedure TFrameForm.MakeOrgBitmap; // ݂̉摜 OrgBitmap ɕۑ葱
begin
  if TurboImage1.Picture.Graphic = Nil then
    Exit;
  if (TurboImage1.Picture.Graphic is TBitmap) or
     (TurboImage1.Picture.Graphic is TJPEGImage) or
     (TurboImage1.Picture.Graphic is TGIFImage) then
    OrgBitmap.Assign(TurboImage1.Picture.Graphic)
  else
  begin
    OrgBitmap.Width := TurboImage1.Picture.Graphic.Width;
    OrgBitmap.Height := TurboImage1.Picture.Graphic.Height;
    OrgBitmap.Canvas.Draw(0, 0, TurboImage1.Picture.Graphic);
  end;
end;

procedure TFrameForm.MakeDataName;  // ݂̉摜f[^t@Cɕۑ葱
begin
  DataName := ExtractFileDir(Application.ExeName);
  if Length(DataName) > 3 then // [gfBNgȊȌꍇ
    DataName := DataName + '\';

  if TurboImage1.Picture.Graphic is TBitmap then
    DataName := DataName + 'ImageData.bmp'
  else if TurboImage1.Picture.Graphic is TMetafile then
  begin
    if TurboImage1.Picture.Metafile.Enhanced then
      DataName := DataName + 'ImageData.emf'
    else
      DataName := DataName + 'ImageData.wmf';
  end
  else if TurboImage1.Picture.Graphic is TIcon then
    DataName := DataName + 'ImageData.ico'
  else if TurboImage1.Picture.Graphic is TJPEGImage then
    DataName := DataName + 'ImageData.jpg'
  else if TurboImage1.Picture.Graphic is TGIFImage then
    DataName := DataName + 'ImageData.gif'
  else
    DataName := DataName + 'ImageData.dat';

  TurboImage1.Picture.SaveToFile(DataName);
end;

procedure TFrameForm.DeleteDataName; // f[^t@C폜葱
begin
  if (DataName <> '') and (DataName <> FileName) and FileExists(DataName) then
    DeleteFile(DataName);
end;

procedure TFrameForm.Button1Click(Sender: TObject);
var
  i: Integer;
  R: TRect;
  Bmp: TBitmap;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  if TrackBar1.Position = 100 then
    Exit;

  if A1.Checked then
    A1Click(Sender); // g~OGAB

  i := ComboBox1.ItemIndex;
  R := Rect(0, 0, TurboImage1.Width, TurboImage1.Height);

  if TurboImage1.Picture.Graphic is TMetafile then
  begin
    Mf := TMetafile.Create;
    try
      Mf.Width := TurboImage1.Width;
      Mf.Height := TurboImage1.Height;
      MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
      try
        MfCanvas.StretchDraw(R, TurboImage1.Picture.Metafile);
      finally
        MfCanvas.Free;
      end;
      TurboImage1.Picture.Graphic := Mf;
    finally
      Mf.Free;
    end;
    Button2Click(Sender);
  end
  else
  begin
    if S1.Checked then // X[YȊgEk
    begin
      TurboImage1.Picture.Graphic := OrgBitmap;
      if TrackBar1.Position > 100 then
        TurboImage1.Enlarge(R.Right, R.Bottom)
      else
        TurboImage1.Shrink(R.Right, R.Bottom);
    end
    else // ʏ̊gEk
    begin
      Bmp := TBitmap.Create;
      try
        Bmp.Width := TurboImage1.Width;
        Bmp.Height := TurboImage1.Height;
        Bmp.Canvas.StretchDraw(R, OrgBitmap);
        TurboImage1.Picture.Graphic := Bmp;
      finally
        Bmp.Free;
      end;
    end;
    MakeOrgBitmap;
    AmendImage; // PxEK}lERgXgE邳𒲐
  end;

  if (i = 3) and (TrackBar6.Position > 0) then // ␳Ăꍇ
    TurboImage1.Automatic(TrackBar6.Position - 1);

  if i in [1..4] then
  begin
    ComboBox1.ItemIndex := i;
    ComboBox1Change(Sender);
  end;

  Tag := -1;
  TrackBar1.Position := 100;
  Tag := 0;

  DrawInfor;     // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.TrackBar2Change(Sender: TObject);
begin
  Label3.Caption := '邳 ( ' + IntToStr(TrackBar2.Position) + ' % )';
  if (Tag = -1) or (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  Tag := -1;
  TrackBar6.Position := 0; Label11.Caption := '␳x ( 0 )';
  Tag := 0;
  AmendImage; // PxEK}lERgXgE邳𒲐
  DrawInfor;  // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.TrackBar3Change(Sender: TObject);
begin
  Label5.Caption := 'RgXg ( ' + IntToStr(TrackBar3.Position) + ' % )';
  if (Tag = -1) or (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  Tag := -1;
  TrackBar6.Position := 0; Label11.Caption := '␳x ( 0 )';
  Tag := 0;
  AmendImage; // PxEK}lERgXgE邳𒲐
  DrawInfor;  // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.TrackBar4Change(Sender: TObject);
var
  G: Extended;
begin
  G := TrackBar4.Position / 60.00;
  G := Power(10.00, G);
  Label7.Caption := 'K}l ( ' + FormatFloat('0.00', G) + ' )';
  if (Tag = -1) or (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  Tag := -1;
  TrackBar6.Position := 0; Label11.Caption := '␳x ( 0 )';
  Tag := 0;
  AmendImage; // PxEK}lERgXgE邳𒲐
  DrawInfor;  // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Button2Click(Sender: TObject);
begin
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  MakeOrgBitmap; // \̉摜 OrgBitmap ɕۑB
  Tag := -1;
  TrackBar6.Position := 0; Label11.Caption := '␳x ( 0 )';
  TrackBar5.Position := 0; Label9.Caption := 'Px ( +0 )';
  TrackBar4.Position := 0; Label7.Caption := 'K}l ( 1.00 )';
  TrackBar3.Position := 100; Label5.Caption := 'RgXg ( 100 % )';
  TrackBar2.Position := 100; Label3.Caption := '邳 ( 100 % )';
  Tag := 0;
end;

procedure TFrameForm.OpenFile(FName: String);
var
  SearchRec: TSearchRec;
  i, j: Integer;
  W, H: Integer;
  Ratio: Integer;
  err: Boolean;
begin
  if FName = '' then
    Exit;
  TurboImage1.Picture.Graphic := Nil;
  TrackBar6.Position := 0; Label11.Caption := '␳x ( 0 )';
  TrackBar5.Position := 0; Label9.Caption := 'Px ( +0 )';
  TrackBar4.Position := 0; Label7.Caption := 'K}l ( 1.00 )';
  TrackBar3.Position := 100; Label5.Caption := 'RgXg ( 100 % )';
  TrackBar2.Position := 100; Label3.Caption := '邳 ( 100 % )';
  TrackBar1.Position := 100; Label2.Caption := '\{ ( 100 % )';

  err := False;
  TurboImage1.Stretch := False;
  try
    TurboImage1.Picture.LoadFromFile(FName);
  except
    err := True;
  end;

  if err then
  begin
    TurboImage1.Stretch := True;
    TurboImage1.Picture.Graphic := Nil;
    FileName := '';
    DataName := '';
    DrawInfor; // LvVɉ摜̏\B
    DrawHistgram;
    ShowMessage(FName + ' ͊J܂B');
    Exit;
  end;

  if TurboImage1.Picture.Graphic <> Nil then
  begin
    if FileName = DataName then // 摜t@C\Ăꍇ
    begin
      FindFirst(FName, faAnyFile, SearchRec);
      i := SearchRec.Size;
      FindClose(SearchRec);
      j := i div 1024;
      if (i mod 1024) <> 0 then
      begin
        if (j = 0) or ((i mod 1024) >= 512) then
          Inc(j);
      end;
      FileSize := '  ' + IntToStr(j) + 'KB';
    end
    else // Drag & Drop 邢́ACopy & Paste ꂽ摜\Ăꍇ
      FileSize := '';

    if FileName = DataName then
      OpenDir := ExtractFileDir(FName);
    W := TurboImage1.Picture.Graphic.Width;
    H := TurboImage1.Picture.Graphic.Height;
    if W > H then i := W else i := H;
    Ratio := 100;
    if i > 1024 then
    begin
      Ratio := 1024 * 100 div i;
      Ratio := (Ratio div 10) * 10;
      if Ratio = 0 then
        Ratio := TrackBar1.Frequency;
    end;

    MakeOrgBitmap; // J摜 OrgBitmap ɕۑB

    if TrackBar1.Position <> Ratio then
      TrackBar1.Position := Ratio
    else
    begin
      W := W * Ratio div 100;
      H := H * Ratio div 100;
      TurboImage1.Width := W;
      TurboImage1.Height := H;
    end;
  end;
  TurboImage1.Stretch := True;
  DrawInfor;     // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Undo;
begin
  if TurboImage1.Picture.Graphic is TBitmap then
  begin
    Tag := -1;
    TrackBar6.Position := 0; Label11.Caption := '␳x ( 0 )';
    TrackBar5.Position := 0; Label9.Caption := 'Px ( +0 )';
    TrackBar4.Position := 0; Label7.Caption := 'K}l ( 1.00 )';
    TrackBar3.Position := 100; Label5.Caption := 'RgXg ( 100 % )';
    TrackBar2.Position := 100; Label3.Caption := '邳 ( 100 % )';
    TrackBar1.Position := 100; Label2.Caption := '\{ ( 100 % )';
    Tag := 0;
    TurboImage1.Picture.Graphic := OrgBitmap;
    DrawInfor; // LvVɉ摜̏\B
    DrawHistgram;
    if PageControl1.ActivePage = TabSheet1 then
      TrackBar6.SetFocus;
  end;
end;

procedure TFrameForm.U1Click(Sender: TObject);
begin
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  Undo;
end;

procedure TFrameForm.O1Click(Sender: TObject);
begin
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  OpenFile(DataName);
  UpDown10.Position := -1;
  if PageControl1.ActivePage = TabSheet1 then
    TrackBar6.SetFocus;
end;

procedure TFrameForm.DrawHistgram;
var
  Mf: TMetafile;
begin
  if H1.Checked then
  begin
    if A1.Checked then
      DrawTrimArea; // g~OGAꎞIɏB
    Mf := TMetafile.Create;
    try
      TurboImage1.Histgram(TGraphic(Mf), 2, 2, 0);
      HistgramForm.Image1.Picture.Graphic := Mf;
    finally
      Mf.Free;
    end;
    if A1.Checked then
      DrawTrimArea; // g~OGAĂѕ`B
  end;
end;

procedure TFrameForm.AmendImage;
var
  Area: Boolean;
  G: Extended;
begin
  Area := A1.Checked;
  if Area then // g~OGAB
  begin
    TrimEnd;
    A1.Checked := False;
    T1.Enabled := False;
  end;
  TurboImage1.Picture.Graphic := OrgBitmap;
  TurboImage1.Light(TrackBar5.Position); // Px
  G := TrackBar4.Position / 60.00;
  G := Power(10.00, G);
  TurboImage1.Gamma(G); // K}␳
  TurboImage1.Contrast(TrackBar3.Position); // RgXg
  TurboImage1.Bright(TrackBar2.Position); // 邳
  if Area then
  begin
    TrimInit;
    A1.Checked := True;
    T1.Enabled := True;
  end;
end;

{ LvVɉ摜̏\B}
procedure TFrameForm.DrawInfor;
var
  BC: Integer;
  PD: PDIBSection;
  Bmp: TBitmap;
  gt, pt, ht: Integer;
begin
  gt := GraphicType; // ݂̃OtBbN̎
  pt := PixelType;   // ݂ PixelFormat ̒l
  ht := HType;       // ݂ HandleType ̒l

  if TurboImage1.Picture.Graphic = Nil then
  begin
    DataName := '';
    FileName := '';
    FileSize := '';
    DispSize := '';
    BitCount := '';
    BmpType := '';
    Caption := 'ImageAmender Version 0.8';
  end
  else
  begin
    if TurboImage1.Picture.Graphic is TBitmap then
      Bmp := TurboImage1.Picture.Bitmap
    else
      Bmp := OrgBitmap;

    DispSize := '  ( ' + IntToStr(TurboImage1.Width) + ' ~ '
                       + IntToStr(TurboImage1.Height) + ' )';

    // ݂̉摜̃rbgvZ BC ɃZbgB
    BC := 0;
    GetMem(PD, SizeOf(TDIBSection) * 100); // Get sufficiently large buffer.
    try
      if GetObject(Bmp.Handle, SizeOf(TDIBSection), PD) <> 0 then
        BC := PD^.dsBmih.biBitCount; // GetObject function succeeds.
    finally
      FreeMem(PD);
    end;
    if gt = 2 then
      BC := 8;
    BitCount := '  -  ' + IntToStr(BC) + ' bit Color';

    case pt of
      0: BmpType := ' ( pfDevice - ';
      1: BmpType := ' ( pf1bit - ';
      2: BmpType := ' ( pf4bit - ';
      3: BmpType := ' ( pf8bit - ';
      4: BmpType := ' ( pf15bit - ';
      5: BmpType := ' ( pf16bit - ';
      6: BmpType := ' ( pf24bit - ';
      7: BmpType := ' ( pf32bit - ';
      8: BmpType := ' ( pfcustom - ';
    else
      BmpType := ' ( pfUnknown - ';
    end;

    case ht of
      0: BmpType := BmpTYpe + 'bmDIB )';
      1: BmpType := BmpTYpe + 'bmDDB )';
    else
      BmpType := BmpTYpe + 'bmUnknown )';
    end;

    Caption := FileName + FileSize + DispSize + BitCount + BmpType;
  end;
  ComboBox1.ItemIndex := gt; // ݂̃OtBbN̎ނ\B
  ComboBox2.ItemIndex := pt; // ݂ PixelFormat ̒l\B
  ComboBox3.ItemIndex := ht; // ݂ HandleType ̒l\B
end;

procedure TFrameForm.Octree2561Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Reduce(rdcOctree);
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.MedianCut2561Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Reduce(rdcMedianCut);
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.MedianCutByVariance2561Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Reduce(rdcMedianCutV);
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.MedianCut2562Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Reduce(rdcMedianCutE);
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.MedianCut2563Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Reduce(rdcMedianCutVE);
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.N4Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Reduce(rdcStaticE);
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.PixelFormat2561Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Picture.Bitmap.PixelFormat := pf8bit;
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.N901Click(Sender: TObject);
var
  W, H: Integer;
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Stretch := False;
  W := TurboImage1.Width;
  H := TurboImage1.Height;
  TurboImage1.Turn(90);
  TurboImage1.Height := W;
  TurboImage1.Width := H;
  TurboImage1.Stretch := True;
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor; // LvVɉ摜̏\B
end;

procedure TFrameForm.N1801Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Turn(180);
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor; // LvVɉ摜̏\B
end;

procedure TFrameForm.N2701Click(Sender: TObject);
var
  W, H: Integer;
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Stretch := False;
  W := TurboImage1.Width;
  H := TurboImage1.Height;
  TurboImage1.Turn(270);
  TurboImage1.Height := W;
  TurboImage1.Width := H;
  TurboImage1.Stretch := True;
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor; // LvVɉ摜̏\B
end;

procedure TFrameForm.R1Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Reverse;
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor; // LvVɉ摜̏\B
end;

procedure TFrameForm.H1Click(Sender: TObject);
begin
  if H1.Checked then
    HistgramForm.Close
  else
  begin
    HistgramForm := THistgramForm.Create(Self);
    HistgramForm.Show;
  end;
end;

{ g~OGA̕`Jnׂ̎葱 }
procedure TFrameForm.TrimInit;
var
  L, T, R, B: Integer;
  W, H: Integer;
begin
  TurboImage1.Canvas.Pen.Color := clBlack;
  TurboImage1.Canvas.Pen.Width := 2;
  TurboImage1.Canvas.Pen.Mode := pmNotXor;
  TurboImage1.Canvas.Pen.Style := psSolid;
  TurboImage1.Canvas.Brush.Style := bsClear;

  L := TrimArea.Left;
  T := TrimArea.Top;
  R := TrimArea.Right;
  B := TrimArea.Bottom;
  W := TurboImage1.Width;
  H := TurboImage1.Height;
  if R > W - 1 then
  begin
    R := W - 1;
    if L >= R then
    begin
      L := R - 1;
      if L < 0 then
        L := 0;
    end;
  end;
  if B > H - 1 then
  begin
    B := H - 1;
    if T >= B then
    begin
      T := B - 1;
      if T < 0 then
        T := 0;
    end;
  end;
  TrimArea := Rect(L, T, R, B);

  DrawTrimArea;

  ComboBox1.ItemIndex := GraphicType; // ݂̃OtBbN̎ނ\B
end;

{ g~OGA`悷葱 }
procedure TFrameForm.DrawTrimArea;
var
  L, T, R, B: Integer;
begin
  L := TrimArea.Left;
  T := TrimArea.Top;
  R := TrimArea.Right;
  B := TrimArea.Bottom;
  TurboImage1.Canvas.Rectangle(L, T, R, B);
end;

{ g~OGA̕`Iׂ̎葱 }
procedure TFrameForm.TrimEnd;
begin
  DrawTrimArea;
  TurboImage1.Canvas.Pen.Mode := pmCopy
end;

procedure TFrameForm.A1Click(Sender: TObject);
begin
  if TurboImage1.Picture.Graphic is TIcon then
    Exit;

  if A1.Checked then
  begin
    TrimEnd;
    A1.Checked := False;
    T1.Enabled := False;
  end
  else
  begin
    if not (TurboImage1.Picture.Graphic is TBitmap) then
      AmendImage;
    TrimInit;
    A1.Checked := True;
    T1.Enabled := True;
  end;
end;

procedure TFrameForm.TurboImage1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  S: Integer;
  W, H: Integer;
  L, T, R, B: Integer;
  Col: TColor;
begin
  DragPoint := Point(X, Y);

  if ComboBox1.ItemIndex = 3 then // Bitmap ̏ꍇ̂݉\
  begin
    Col := TurboImage1.Canvas.Pixels[X, Y];
    Panel7.Color := Col;
    Label21.Caption := Format('$%8.8x  =', [Integer(Panel7.Color)]);
  end;

  if (not A1.Checked) or (not (Button in [mbLeft, mbRight])) then
    Exit;

  DrawTrimArea;
  S := TrackBar1.Position;
  { Rectangle ̊ep[^̒ĺATurboImage1.Canvas ł͂Ȃ }
  { TurboImge1.Picture.Graphic ̈ʒuӖ̂ŁAx, Y ̒l␳B}
  if S <> 100 then
  begin
    X := X * 100 div S;
    Y := Y * 100 div S;
  end;
  L := TrimArea.Left;
  T := TrimArea.Top;
  R := TrimArea.Right;
  B := TrimArea.Bottom;
  W := R - L;
  H := B - T;
  if Button = mbLeft then
  begin
    L := X;
    R := L + W;
    if R > TurboImage1.Picture.Graphic.Width - 1 then
    begin
      R := TurboImage1.Picture.Graphic.Width - 1;
      L := R - W;
    end;
    T := Y;
    B := T + H;
    if B > TurboImage1.Picture.Graphic.Height - 1 then
    begin
      B := TurboImage1.Picture.Graphic.Height - 1;
      T := B - H;
    end;
  end
  else if Button = mbRight then
  begin
    R := X;
    B := Y;
  end;
  TrimArea := Rect(L, T, R, B);
  DrawTrimArea;
end;

procedure TFrameForm.T1Click(Sender: TObject);
var
  L, T, R, B: Integer;
  S: Integer;
begin
  if TurboImage1.Picture.Graphic is TIcon then
    Exit;

  A1Click(Sender); // g~OGAB
  L := TrimArea.Left;
  T := TrimArea.Top;
  R := TrimArea.Right;
  B := TrimArea.Bottom;
  S := TrackBar1.Position;
  { Rectangle ̊ep[^̒ĺATurboImage1.Canvas ł͂Ȃ }
  { TurboImge1.Picture.Graphic ̈ʒuӖ̂Ŋel␳B}
  if S <> 100 then
  begin
    L := L * S div 100;
    T := T * S div 100;
    R := R * S div 100;
    B := B * S div 100;
  end;
  TrimArea := Rect(L, T, R, B);
  TurboImage1.Trimming(TrimArea, False); // g~O̎s
  Button2Click(Sender); // ݂̉摜(掿)ɂB
  DrawInfor;
  DrawHistgram;
end;

procedure TFrameForm.TrackBar5Change(Sender: TObject);
var
  p: Integer;
  S: String;
begin
  p := TrackBar5.Position;
  S := IntToStr(p);
  if p >= 0 then
    S := '+' + S;
  Label9.Caption := 'Px ( ' + S + ' )';
  if (Tag = -1) or (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  Tag := -1;
  TrackBar6.Position := 0; Label11.Caption := '␳x ( 0 )';
  Tag := 0;
  AmendImage; // PxEK}lERgXgE邳𒲐
  DrawInfor;  // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.TurboImage1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  Area: Boolean;
  R: TRect;
  Bmp: TBitmap;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  if (Shift <> [ssLeft]) or (TurboImage1.Picture.Graphic = Nil) then
    Exit;

  if (Abs(X - DragPoint.X) < Mouse.DragThreshold) and
     (Abs(Y - DragPoint.Y) < Mouse.DragThreshold) then
    Exit;

  DropPictureTarget1.DragTypes := []; // Disable SCrollBox1 target temporarily.

  Area := A1.Checked;
  if Area then
    A1Click(Sender); // g~OGAB

  R := Rect(0, 0, TurboImage1.Width, TurboImage1.Height);

  if TurboImage1.Picture.Graphic is TMetafile then
  begin
    if TrackBar1.Position = 100 then
      DropMetaSource1.Metafile := TurboImage1.Picture.Metafile
    else
    begin
      Mf := TMetafile.Create;
      try
        Mf.Width := TurboImage1.Width;
        Mf.Height := TurboImage1.Height;
        MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
        try
          MfCanvas.StretchDraw(R, TurboImage1.Picture.Metafile);
        finally
          MfCanvas.Free;
        end;
        DropMetaSource1.Metafile := Mf;
      finally
        Mf.Free;
      end;
    end;
    DropMetaSource1.Execute; // Do it here - dragging from TurboImage1.
  end
  else
  begin
    Bmp := TBitmap.Create;
    try
      Bmp.Width := TurboImage1.Width;
      Bmp.Height := TurboImage1.Height;
      Bmp.Canvas.StretchDraw(R, TurboImage1.Picture.Graphic);
      DropBMPSource1.Bitmap := Bmp;
    finally
      Bmp.Free;
    end;
    DropBMPSource1.Execute; // Do it here - dragging from TurboImage1.
  end;

  if Area then
    A1Click(Sender); // g~OGAĂѕ\B

  DropPictureTarget1.DragTypes := [dtCopy, dtMove, dtLink]; // Enable ScrollBox1 as a drop target again.
end;

procedure TFrameForm.FormCreate(Sender: TObject);
begin
  { tH[ւ̃hbOhbvB}
  DragAcceptFiles(Handle, True);

  DropPictureTarget1.Register(ScrollBox1);
end;

procedure TFrameForm.FormDestroy(Sender: TObject);
begin
  DropPictureTarget1.UnregisterAll;
end;

procedure TFrameForm.DropPictureTarget1Drop(Sender: TObject;
  ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
var
  i: Integer;
  W, H: Integer;
  Ratio: Integer;
begin
  if A1.Checked then
    A1Click(Sender); // g~OGAB

  TurboImage1.Picture.Graphic := Nil;
  TrackBar6.Position := 0; Label11.Caption := '␳x ( 0 )';
  TrackBar5.Position := 0; Label9.Caption := 'Px ( +0 )';
  TrackBar4.Position := 0; Label7.Caption := 'K}l ( 1.00 )';
  TrackBar3.Position := 100; Label5.Caption := 'RgXg ( 100 % )';
  TrackBar2.Position := 100; Label3.Caption := '邳 ( 100 % )';
  TrackBar1.Position := 100; Label2.Caption := '\{ ( 100 % )';

  TurboImage1.Stretch := False;
  TurboImage1.Picture.Assign(DropPictureTarget1.Picture); // Dragging to Image1

  if TurboImage1.Picture.Graphic <> Nil then
  begin
    DeleteDataName; // f[^t@C폜B

    if TurboImage1.Picture.Graphic is TMetafile then
      FileName := 'Dropped Metafile'
    else if TurboImage1.Picture.Graphic is TBitmap then
      FileName := 'Dropped Bitmap'
    else if TurboImage1.Picture.Graphic is TJPEGImage then
      FileName := 'Dropped JPEG'
    else if TurboImage1.Picture.Graphic is TIcon then
      FileName := 'Dropped Icon'
    else
      FileName := 'Dropped Image';
    FileSize := '';
    W := TurboImage1.Picture.Graphic.Width;
    H := TurboImage1.Picture.Graphic.Height;
    if W > H then i := W else i := H;
    Ratio := 100;
    if i > 1024 then
    begin
      Ratio := 1024 * 100 div i;
      Ratio := (Ratio div 10) * 10;
      if Ratio = 0 then
        Ratio := TrackBar1.Frequency;
    end;

    MakeOrgBitmap; // J摜 OrgBitmap ɕۑB
    MakeDataName;  // J摜f[^t@CɕۑB

    if TrackBar1.Position <> Ratio then
      TrackBar1.Position := Ratio
    else
    begin
      W := W * Ratio div 100;
      H := H * Ratio div 100;
      TurboImage1.Width := W;
      TurboImage1.Height := H;
    end;
    PageControl1.ActivePage := TabSheet1;
    TrackBar6.SetFocus;
  end;
  TurboImage1.Stretch := True;
  DrawInfor;     // LvVɉ摜̏\B
  DrawHistgram;
  UpDown10.Position := -1;
end;

procedure TFrameForm.GetJPEG;
var
  Jpeg: TJPEGImage;
  MemStream: TMemoryStream;
begin
  Jpeg := TJPEGImage.Create;
  Jpeg.CompressionQuality := UpDown1.Position;
  try
    MemStream := TMemoryStream.Create;
    try
      Clipboard2Stream(CF_JFIF, MemStream);
      Jpeg.LoadFromStream(MemStream);
      TurboImage1.Picture.Assign(Jpeg);
    finally
      MemStream.Free;
    end;
  finally
    Jpeg.Free;
  end;
end;

procedure TFrameForm.GetGIF;
var
  Gif: TGIFImage;
  MemStream: TMemoryStream;
begin
  Gif := TGIFImage.Create;
  try
    MemStream := TMemoryStream.Create;
    try
      Clipboard2Stream(CF_GIF, MemStream);
      Gif.LoadFromStream(MemStream);
      TurboImage1.Picture.Assign(Gif);
    finally
      MemStream.Free;
    end;
  finally
    Gif.Free;
  end;
end;

function TFrameForm.Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
var
  Data: THandle;
  DataPtr: Pointer;
begin
  Result := False;
  if MemStream.Size = 0 then
    Exit;
  Data := GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE, MemStream.Size);
  try
    DataPtr := GlobalLock(Data);
    try
      MemStream.Position := 0;
      MemStream.ReadBuffer(DataPtr^, MemStream.Size);
      MemStream.Position := 0;
    finally
      GlobalUnlock(Data);
    end;
    Clipboard.SetAsHandle(Format, Data);
  except
    GlobalFree(Data);
    raise;
  end;
  Result := True;
end;

function TFrameForm.Clipboard2Stream(Format: Word; MemStream: TMemoryStream): Boolean;
var
  Data: THandle;
  DataPtr: Pointer;
  MSize: Integer;
  MPtr: Pointer; // ꎞǂݍݗpobt@
begin
  Result := False;
  Data := Clipboard.GetAsHandle(Format);
  if Data = 0 then
    Exit;
  DataPtr := GlobalLock(Data);
  if DataPtr = Nil then
    Exit;
  try
    MSize :=  GlobalSize(Data);
    GetMem(MPtr, MSize);
    try
      Move(DataPtr^, MPtr^, MSize); // Uobt@ɓǂݍ
      MemStream.Position := 0;
      MemStream.WriteBuffer(MPtr^, MSize); // 炽߂MemoryStreamɏ
      MemStream.Position := 0;
    finally
      FreeMem(MPtr);
    end;
  finally
    GlobalUnlock(Data);
  end;
  Result := True;
end;

procedure TFrameForm.Copy1Click(Sender: TObject);
var
  Area: Boolean;
  R: TRect;
  Bmp: TBitmap;
  Jpeg: TJPEGImage;
  Gif: TGIFImage;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
  MemStream: TMemoryStream;
begin
  if TurboImage1.Picture.Graphic = Nil then
    Exit;

  Area := A1.Checked;
  if Area then
    A1Click(Sender); // g~OGAB

  R := Rect(0, 0, TurboImage1.Width, TurboImage1.Height);

  Bmp := TBitmap.Create;
  try
    Bmp.Width := TurboImage1.Width;
    Bmp.Height := TurboImage1.Height;
    Bmp.Canvas.StretchDraw(R, TurboImage1.Picture.Graphic);

    if TurboImage1.Picture.Graphic is TMetafile then
    begin
      Mf := TMetafile.Create;
      try
        Mf.Width := TurboImage1.Width;
        Mf.Height := TurboImage1.Height;
        MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
        try
          MfCanvas.StretchDraw(R, TurboImage1.Picture.Metafile);
        finally
          MfCanvas.Free;
        end;
        Clipboard.Assign(Mf);
      finally
        Mf.Free;
      end;
    end
    else if TurboImage1.Picture.Graphic is TBitmap then
      Clipboard.Assign(Bmp)
    else if TurboImage1.Picture.Graphic is TJPEGImage then
    begin
      Jpeg := TJPEGImage.Create;
      Jpeg.CompressionQuality := UpDown1.Position;
      try
        Jpeg.Assign(Bmp);
        MemStream := TMemoryStream.Create;
        try
          Jpeg.SaveToStream(MemStream);
          Stream2Clipboard(CF_JFIF, MemStream);
        finally
          MemStream.Free;
        end;
      finally
        Jpeg.Free;
      end;
    end
    else if TurboImage1.Picture.Graphic is TGIFImage then
    begin
      Gif := TGIFImage.Create;
      try
        Gif.Assign(Bmp);
        MemStream := TMemoryStream.Create;
        try
          Gif.SaveToStream(MemStream);
          Stream2Clipboard(CF_GIF, MemStream);
        finally
          MemStream.Free;
        end;
      finally
        Gif.Free;
      end;
    end
    else
      Clipboard.Assign(TurboImage1.Picture);
  finally
    Bmp.Free;
  end;

  if Area then
    A1Click(Sender); // g~OGAĂяB
end;

procedure TFrameForm.Paste1Click(Sender: TObject);
var
  i: Integer;
  W, H: Integer;
  Ratio: Integer;
begin
  if not Clipboard.HasFormat(CF_PICTURE) then
    Exit;

  if A1.Checked then
    A1Click(Sender); // g~OGAB

  TurboImage1.Picture.Graphic := Nil;
  TrackBar6.Position := 0; Label11.Caption := '␳x ( 0 )';
  TrackBar5.Position := 0; Label9.Caption := 'Px ( +0 )';
  TrackBar4.Position := 0; Label7.Caption := 'K}l ( 1.00 )';
  TrackBar3.Position := 100; Label5.Caption := 'RgXg ( 100 % )';
  TrackBar2.Position := 100; Label3.Caption := '邳 ( 100 % )';
  TrackBar1.Position := 100; Label2.Caption := '\{ ( 100 % )';

  TurboImage1.Stretch := False;
  if Clipboard.HasFormat(CF_JFIF) then
    GetJPEG
  else if Clipboard.HasFormat(CF_GIF) then
    GetGIF
  else
    TurboImage1.Picture.Assign(Clipboard);

  if TurboImage1.Picture.Graphic <> Nil then
  begin
    DeleteDataName; // f[^t@C폜B

    if TurboImage1.Picture.Graphic is TMetafile then
      FileName := 'Copied Metafile'
    else if TurboImage1.Picture.Graphic is TBitmap then
      FileName := 'Copied Bitmap'
    else if TurboImage1.Picture.Graphic is TJPEGImage then
      FileName := 'Copied JPEG'
    else if TurboImage1.Picture.Graphic is TGIFImage then
      FileName := 'Copied GIF'
    else if TurboImage1.Picture.Graphic is TIcon then
      FileName := 'Copied Icon'
    else
      FileName := 'Copied Image';
    FileSize := '';
    W := TurboImage1.Picture.Graphic.Width;
    H := TurboImage1.Picture.Graphic.Height;
    if W > H then i := W else i := H;
    Ratio := 100;
    if i > 1024 then
    begin
      Ratio := 1024 * 100 div i;
      Ratio := (Ratio div 10) * 10;
      if Ratio = 0 then
        Ratio := TrackBar1.Frequency;
    end;

    MakeOrgBitmap; // J摜 OrgBitmap ɕۑB
    MakeDataName;  // J摜f[^t@CɕۑB

    if TrackBar1.Position <> Ratio then
      TrackBar1.Position := Ratio
    else
    begin
      W := W * Ratio div 100;
      H := H * Ratio div 100;
      TurboImage1.Width := W;
      TurboImage1.Height := H;
    end;
    PageControl1.ActivePage := TabSheet1;
    TrackBar6.SetFocus;
  end;
  TurboImage1.Stretch := True;
  DrawInfor;     // LvVɉ摜̏\B
  DrawHistgram;
  UpDown10.Position := -1;
end;

procedure TFrameForm.Button4Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Edge(UpDown2.Position);
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Button5Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Median(UpDown3.Position);
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

{ ݂̃OtBbN̎ނԂ֐ }
function TFrameForm.GraphicType: Integer;
begin
  if TurboImage1.Picture.Graphic = Nil then
    Result := 0
  else if TurboImage1.Picture.Graphic is TJPEGImage then
    Result := 1
  else if TurboImage1.Picture.Graphic is TGIFImage then
    Result := 2
  else if TurboImage1.Picture.Graphic is TBitmap then
    Result := 3
  else if TurboImage1.Picture.Graphic is TMetafile then
    Result := 4
  else if TurboImage1.Picture.Graphic is TIcon then
    Result := 5
  else
    Result := 6;
end;

{ ݂ PixelFormat ̒lԂ֐ }
function TFrameForm.PixelType: Integer;
var
  Bmp: TBitmap;
begin
  if TurboImage1.Picture.Graphic is TBitmap then
    Bmp := TurboImage1.Picture.Bitmap
  else
    Bmp := OrgBitmap;

  case Bmp.PixelFormat of
    pfDevice: Result := 0;
    pf1bit:   Result := 1;
    pf4bit:   Result := 2;
    pf8bit:   Result := 3;
    pf15bit:  Result := 4;
    pf16bit:  Result := 5;
    pf24bit:  Result := 6;
    pf32bit:  Result := 7;
    pfcustom: Result := 8;
  else
    Result := 0;
  end;
end;

{ ݂ HandleType ̒lԂ֐ }
function TFrameForm.HType: Integer;
var
  Bmp: TBitmap;
begin
  if TurboImage1.Picture.Graphic is TBitmap then
    Bmp := TurboImage1.Picture.Bitmap
  else
    Bmp := OrgBitmap;

  if Bmp.HandleType = bmDIB then
    Result := 0
  else             // bmDDB
    Result := 1;
end;

procedure TFrameForm.ComboBox1Change(Sender: TObject);
var
  Bmp: TBitmap;
  Jpeg: TJPEGImage;
  Gif: TGIFImage;
  Meta: TMetafile;
  MfCanvas: TMetafileCanvas;
  i, gt: Integer;
begin
  gt := GraphicType; // ݂̃OtBbN̎
  i := ComboBox1.ItemIndex;

  if (i = gt) or (i in [5, 6]) then
  begin
    ComboBox1.ItemIndex := gt; // ɖ߂B
    Exit;
  end;

  if i = 0 then
  begin
    L1Click(Sender);
    Exit;
  end;

  Bmp := TBitmap.Create;
  try
    if (gt in [1..3]) then // JPEG, GIF, Bitmap
      Bmp.Assign(TurboImage1.Picture.Graphic)
    else
    begin
      Bmp.Width := TurboImage1.Picture.Graphic.Width;
      Bmp.Height := TurboImage1.Picture.Graphic.Height;
      Bmp.Canvas.Draw(0, 0, TurboImage1.Picture.Graphic);
    end;

    { ^[Qbgf[^ɕϊB}
    if i = 1 then // JPEG
    begin
      Jpeg := TJPEGImage.Create;
      Jpeg.CompressionQuality := UpDown1.Position;
      try
        Jpeg.Assign(Bmp);
        TurboImage1.Picture.Graphic := Jpeg;
      finally
        Jpeg.Free;
      end;
    end
    else if i = 2 then // GIF
    begin
      Gif := TGIFImage.Create;
      try
        Gif.Assign(Bmp);
        TurboImage1.Picture.Graphic := Gif;
      finally
        Gif.Free;
      end;
    end
    else if i = 3 then // Bitmap
      TurboImage1.Picture.Graphic := Bmp
    else // Metafile
    begin
      Meta := TMetafile.Create;
      try
        Meta.Width := TurboImage1.Picture.Graphic.Width;
        Meta.Height := TurboImage1.Picture.Graphic.Height;
        MfCanvas := TMetafileCanvas.Create(Meta, GetDC(0));
        try
          MfCanvas.Draw(0, 0, Bmp);
        finally
          MfCanvas.Free;
        end;
        TurboImage1.Picture.Graphic := Meta;
      finally
        Meta.Free;
      end;
    end;

  finally
    Bmp.Free;
  end;

  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Button6Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Blur;
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.S1Click(Sender: TObject);
begin
  if S1.Checked then
    S1.Checked := False
  else
    S1.Checked := True;
end;

procedure TFrameForm.Button7Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Sobel(UpDown4.Position, True);
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Button8Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Mosaic(UpDown5.Position);
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Button9Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Posterization(UpDown6.Position);
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Button10Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Sobel(UpDown7.Position, False);
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Button11Click(Sender: TObject);
var
  FL: Boolean;
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if RadioButton1.Checked then
    FL := True
  else
    FL := False;
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Framing(UpDown8.Position, UpDown9.Position, FL);
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Button12Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.GrayScale;
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Button13Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Sepia;
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Button14Click(Sender: TObject);
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  TurboImage1.Negative;
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.ComboBox2Change(Sender: TObject);
var
  i, pt: Integer;
  pf: TPixelFormat;
begin
  pt := PixelType; // ݂ PixelFormat ̒l
  i := ComboBox2.ItemIndex;

  if (i = pt) or (TurboImage1.PictureType <> picBitmap) then
  begin
    ComboBox2.ItemIndex := pt; // ɖ߂B
    Exit;
  end;

  case i of
    0: pf := pfDevice;
    1: pf := pf1bit;
    2: pf := pf4bit;
    3: pf := pf8bit;
    4: pf := pf15bit;
    5: pf := pf16bit;
    6: pf := pf24bit;
    7: pf := pf32bit;
    8: pf := pfcustom;
  else
    pf := pfDevice;
  end;

  TurboImage1.Picture.Bitmap.PixelFormat := pf;
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.ComboBox3Change(Sender: TObject);
var
  i, ht: Integer;
begin
  ht := HType; // ݂ HandleType ̒l
  i := ComboBox3.ItemIndex;

  if (i = ht) or (TurboImage1.PictureType <> picBitmap) then
  begin
    ComboBox3.ItemIndex := ht; // ɖ߂B
    Exit;
  end;

  case i of
    0: TurboImage1.Picture.Bitmap.HandleType := bmDIB;
    1: TurboImage1.Picture.Bitmap.HandleType := bmDDB;
  else
    TurboImage1.Picture.Bitmap.HandleType := bmDDB;
  end;

  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.Button15Click(Sender: TObject);
var
  Border: Integer;
begin
  if (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  if not (TurboImage1.Picture.Graphic is TBitmap) then
    AmendImage;
  Border := UpDown10.Position;
  TurboImage1.BlackAndWhite(UpDown10.Position, Border);
  if UpDown10.Position = -1 then
    UpDown10.Position := Border; // ۂ̋El
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.V1Click(Sender: TObject);
begin
  if TurboImage1.Picture.Graphic = Nil then
    Exit;
  PreviewForm := TPreviewForm.Create(Self);
  PreviewForm.ShowModal;
  PreviewForm.Free;
end;

procedure TFrameForm.T2Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TFrameForm.TrackBar6Change(Sender: TObject);
begin
  Label11.Caption := '␳x ( ' + IntToStr(TrackBar6.Position) + ' )';
  if (Tag = -1) or (TurboImage1.PictureType in [picNil, picIcon]) then
    Exit;
  if A1.Checked then
    A1Click(Sender); // g~OGAB
  Tag := -1;
  TrackBar5.Position := 0; Label9.Caption := 'Px ( +0 )';
  TrackBar4.Position := 0; Label7.Caption := 'K}l ( 1.00 )';
  TrackBar3.Position := 100; Label5.Caption := 'RgXg ( 100 % )';
  TrackBar2.Position := 100; Label3.Caption := '邳 ( 100 % )';
  Tag := 0;
  TurboImage1.Picture.Graphic := OrgBitmap;
  TurboImage1.Automatic(TrackBar6.Position - 1);
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

procedure TFrameForm.H2Click(Sender: TObject);
var
  FileName: TFileName;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'Readme.txt';
  ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.About1Click(Sender: TObject);
begin
  ShellAbout(Handle, PChar(Application.Title),
             #13#10 + 'ImageAmender  Version 0.8 Copyright (C) 2017 ` 2023 seizo',
             Application.Icon.Handle);
end;

procedure TFrameForm.L1Click(Sender: TObject);
begin
  TurboImage1.Picture.Graphic := Nil;
  FileName := '';
  DataName := '';
  TrackBar6.Position := 0; Label11.Caption := '␳x ( 0 )';
  TrackBar5.Position := 0; Label9.Caption := 'Px ( +0 )';
  TrackBar4.Position := 0; Label7.Caption := 'K}l ( 1.00 )';
  TrackBar3.Position := 100; Label5.Caption := 'RgXg ( 100 % )';
  TrackBar2.Position := 100; Label3.Caption := '邳 ( 100 % )';
  TrackBar1.Position := 100; Label2.Caption := '\{ ( 100 % )';
  DrawInfor; // LvVɉ摜̏\B
  DrawHistgram;
end;

initialization
  CF_JFIF := RegisterClipboardFormat('JFIF');
  TPicture.RegisterClipboardFormat(CF_JFIF, TJPEGImage);
  RegisterClass(TJPEGImage);

  CF_GIF := RegisterClipboardFormat('GIF Image');
  TPicture.RegisterClipboardFormat(CF_GIF, TGIFImage);
  RegisterClass(TGIFImage);

end.
