unit Histgram;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  THistgramForm = class(TForm)
    Image1: TImage;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  HistgramForm: THistgramForm;

implementation

uses Frame;

{$R *.DFM}

procedure THistgramForm.FormShow(Sender: TObject);
var
  Mf: TMetafile;
begin
  Left := FrameForm.Parameter1['HLeft'];
  Top := FrameForm.Parameter1['HTop'];
  ClientWidth := FrameForm.Parameter1['HClientWidth'];
  ClientHeight := FrameForm.Parameter1['HClientHeight'];
  WindowState := TWindowState(FrameForm.Parameter1['HWindowState']);
  if FrameForm.A1.Checked then
    FrameForm.DrawTrimArea; // g~OGAꎞIɏB
  Mf := TMetafile.Create;
  try
    FrameForm.TurboImage1.Histgram(TGraphic(Mf), 2, 2, 0);
    Image1.Picture.Graphic := Mf;
  finally
    Mf.Free;
  end;
  if FrameForm.A1.Checked then
    FrameForm.DrawTrimArea; // g~OGAĂѕ`B
  FrameForm.H1.Checked := True;
end;

procedure THistgramForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if WindowState <> wsMaximized then
  begin
    FrameForm.Parameter1['HLeft'] := Left;
    FrameForm.Parameter1['HTop'] := Top;
    FrameForm.Parameter1['HClientWidth'] := ClientWidth;
    FrameForm.Parameter1['HClientHeight'] := ClientHeight;
  end;
  FrameForm.Parameter1['HWindowState'] := Integer(WindowState);
  FrameForm.H1.Checked := False;
end;

end.
